

double longitude, latitude;


PImage chicago;
MercatorMap mercatorMap;

PVector zone;

int count;
int count2;

Table potholes;
Table potholescompleted;
String src= "https://data.cityofchicago.org/api/views/7as2-ds3y/rows.csv"; 
String src2= "https://data.cityofchicago.org/api/views/xpdx-8ivx/rows.csv";


void setup() {

  size(620, 800);
  loop();
  smooth();

  ellipseMode(CENTER);


  potholes = loadTable("potholes.csv");
//  potholes = loadTable("potholesFULL.csv");  
//  potholescompleted = loadTable("potholescompleted.csv");
  
//  potholes = loadTable(src);
  potholescompleted = loadTable(src2);

  // Loading exported image
  chicago = loadImage("Chicago.png");

  // Map with dimension and bounding box
  mercatorMap = new MercatorMap(620, 800, 42.04, 41.63, -87.92, -87.49);
  count = potholes.getRowCount();
  count2 = potholescompleted.getRowCount();
}

void draw() {


  //background(0);  
  smooth();
  image(chicago, 0, 0, 620, 800);
  
  textSize(18);
  text("Chicago's Never Ending Battle", (width*.05), (height*.785));
  text("To Smooth Its Streets", (width*.05), (height*.815));
  textSize(12);
  text("filled potholes in the last 7 days", (width*.09), (height*.895));
  text("open 311 requests for potholes", (width*.09), (height*.945));
  
  fill(0);
  stroke(255);
  ellipse((width*.06), (height*.89), 15,15);
  fill(255);
  stroke(255,0,0);
  ellipse((width*.06), (height*.94), 15, 15);







  for (int row = 1; row < count; row++)
  {
    float lon = potholes.getFloat(row, 17);  
    float lat = potholes.getFloat(row, 16);  
    String type = potholes.getString(row, 1);  
    float date = potholes.getFloat(row, 2);
    zone = mercatorMap.getScreenLocation(new PVector(lat, lon ));

    if (type.equals("Open")==true) {
      pushStyle();
      stroke(255, 0, 0);
      strokeWeight(.5);
      fill(255);
      ellipse(zone.x, zone.y, 4, 4 );
      popStyle();
    }
  }



  for (int row2 = 1; row2 < count2; row2++)
  {
    float lon = potholescompleted.getFloat(row2, 16);  
    float lat = potholescompleted.getFloat(row2, 15);  
    String type = potholescompleted.getString(row2, 1);  
    String date = potholescompleted.getString(row2, 2);
    String address = potholescompleted.getString(row2, 8);
    int amount = potholescompleted.getInt(row2, 7);

    zone = mercatorMap.getScreenLocation(new PVector(lat, lon ));

    if (type.equals("Completed")==true) {
      pushStyle();
      stroke(255);
      strokeWeight(.5);
      fill(0, 0, 0);
      ellipse(zone.x, zone.y, 5, 5 );
      popStyle();


      if ((dist(mouseX, mouseY, zone.x, zone.y)<5) & zone.x<.6*width) { 
        pushStyle();
        strokeWeight(1.5);
        stroke(255, 0, 0);
        line (zone.x, zone.y, zone.x+80, zone.y);
        popStyle();
        
        
        pushStyle();
        textSize(11);
        strokeWeight(2);
        stroke(255);
        fill (180, 0, 0); 
        rect(zone.x+85, zone.y-25, 140, 60);
        fill(255); 
        text(date, zone.x+90, zone.y-10);
        text(amount, zone.x+90, zone.y+8);
        text("potholes filled at", zone.x+108, zone.y+8);
        text(address, zone.x+90, zone.y+25);

        popStyle();
      }
      
      if ((dist(mouseX, mouseY, zone.x, zone.y)<5) & zone.x>.6*width) { 
        pushStyle();
        strokeWeight(1.5);
        stroke(255, 0, 0);
        line (zone.x, zone.y, zone.x-80, zone.y);
        popStyle();
        
        
        pushStyle();
        textSize(11);
        textAlign(RIGHT);
        strokeWeight(2);
        stroke(255);
        fill (180, 0, 0); 
        rect(zone.x-85, zone.y-25, -140, 60);
        fill(255); 
        text(date, zone.x-90, zone.y-10);
        text(amount, zone.x-185, zone.y+8);
        text("potholes filled at", zone.x-90, zone.y+8);
        text(address, zone.x-90, zone.y+25);

        popStyle();
      }
    }
  }
}

